import * as vue from 'vue';
import { Ref } from 'vue';
import { TableColumnData } from '@arco-design/web-vue';

interface TableColumnDataPlus extends TableColumnData {
    [key: string]: unknown;
    visible?: boolean;
    children?: TableColumnDataPlus[];
}
declare function useColumns<T extends TableColumnDataPlus>(columns: T[]): {
    originColumns: Ref<T[]>;
    columns: vue.ComputedRef<T[]>;
    resetColumns: () => void;
    changeVisibleByPath: (path: string, visible: string) => void;
    changeVisibleByDataIndex: (dataIndex: string, visible: boolean) => void;
    updateColumnByPath: <K extends keyof T>(path: string, field: K, value: T[K]) => void;
    updateColumnByDataIndex: <K_1 extends keyof T>(dataIndex: string, field: K_1, value: T[K_1]) => void;
    replaceColumnByPath: (path: string, column: T) => void;
    replaceColumnByDataIndex: (dataIndex: string, column: T) => void;
};

export { type TableColumnDataPlus, useColumns };
